/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */

using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Entity;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI.Dialog;

namespace IPluginProjectDisplay_Example
{
    /* Class Declaration: Inherit from Plugin, implement IPluginProjectDisplay */
    public class IPluginProjectDisplay_Example : Plugin, IPluginProjectDisplay
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginProjectDisplay_Example(CPluginApi api)
            : base(api)
        {
        }

        #region IPluginProjectDisplay Members

        public CDialogItem[] ProjectDisplayEdit(CProject project)
        {
            /* display a dialog item for the Project configuration page with content,
             * label and instructions html provided */
            return new CDialogItem[] { new CDialogItem(
                @"<input type=""checkbox"" name=""unused"" />
                Created by ProjectDisplayEdit method.", "Plugin Example",
                "Instructions are shown here.") };
        }

        public string[] ProjectDisplayListFields(CProject project)
        {
            /* Display a field containing the ixProject value for the CProject object */
            return new string[] { HttpUtility.HtmlEncode(project.ixProject.ToString()) };
        }

        public string[] ProjectDisplayListHeaders()
        {
            /* Display a label for our new field */
            return new string[] { "ixProject" };
        }

        #endregion
    }
}